#if !defined(AFX_ROBOTTIMINTDLG_H__93790583_CA9B_11D3_BD58_0090CCA1478A__INCLUDED_)
#define AFX_ROBOTTIMINTDLG_H__93790583_CA9B_11D3_BD58_0090CCA1478A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RobotTimIntDlg.h : header file
//

////////////////////////////////////////////////////////////////////////////
// CRobotTimIntDlg dialog

class CRobotTimIntDlg : public CDialog
{
// Construction
public:
	void OnExtIntPolarity(int ch);
	CRobotTimIntDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CRobotTimIntDlg)
	enum { IDD = IDD_TIMINT_DIALOG };
	CEdit	m_IntTypeEdit;
	CEdit	m_CountEdit;
	CButton	m_IntStatic3;
	CButton	m_IntStatic2;
	CButton	m_IntStatic1;
	CButton	m_IntStatic0;
	CSliderCtrl	m_TimSlider1;
	CEdit	m_TimEdit1;
	CButton	m_TimStatic1;
	CEdit	m_TimEdit0;
	CSliderCtrl	m_TimSlider0;
	CButton	m_TimStatic0;
	int		m_nTim0;
	int		m_nTim1;
	BOOL	m_bEnableGraph;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRobotTimIntDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CRobotTimIntDlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnTimstart1();
	afx_msg void OnTimstart0();
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnKillfocusTimedit0();
	afx_msg void OnKillfocusTimedit1();
	afx_msg void OnEnablemsg();
	afx_msg void OnEnablegraph();
	afx_msg void OnExtIntEdge0();
	afx_msg void OnExtIntEdge1();
	afx_msg void OnExtIntEdge2();
	afx_msg void OnExtIntEdge3();
	afx_msg void OnExtIntPolarity0();
	afx_msg void OnExtIntPolarity1();
	afx_msg void OnExtIntPolarity2();
	afx_msg void OnExtIntPolarity3();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void OnExtIntEdge(int ch);
	BOOL bEnableIntMsg;
	void OnKillFocusTimEdit(int ch);
	BOOL m_abExtInt[4];
	BOOL OnExtIntEn(int ch);
	int m_aiExtIntEnId[4];
	CButton *m_apTimStatic[2];
	CButton *m_apIntStatic[4];
	LRESULT OnIrqMsg(WPARAM wParam, LPARAM lParam);
	int* m_apnTim[2];
	BOOL m_abTimStart[2];
	void OnTimStart(int ch);
	CEdit* m_apTimEdit[2];
	CSliderCtrl* m_apTimSlider[2];
	void OnTimSlider(int ch);
	int m_IntCounter[4];
	int m_TimCounter[2];
	void OnCustomDrawTim(int ch, BOOL bFullDraw=FALSE);

	CPen *pBlackPen, *pOldPen;
	CBrush *pRedBrush, *pGreenBrush, *pOldBrush;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROBOTTIMINTDLG_H__93790583_CA9B_11D3_BD58_0090CCA1478A__INCLUDED_)
