#ifndef	__JWRIBDEF_H__
#define	__JWRIBDEF_H__

#include "jwribpci.h"
#include "RibDef.h"
#include "RibDrvIO.h"
//#include "VxDDef.h"

#ifdef	__cplusplus
extern "C"{
#endif	//__cplusplus
#if	0
}
#endif

//	//	//	//	//	//	//	//	//	//	//	//
ROBOTDLL_API int WINAPI GetVxdVersion(int *pnVersion);
ROBOTDLL_API BOOL WINAPI GetRibGeneralInfo(PJWRIBPCI_GENERAL_INFO pGeneralInfo, DWORD dwSize);

ROBOTDLL_API int WINAPI SetIrqNo(int iIrq);
ROBOTDLL_API int WINAPI SetWndMsg(HANDLE hwnd, UINT uiMsg);
ROBOTDLL_API int WINAPI EnableIntMsg(BOOL bEnable);
ROBOTDLL_API int WINAPI GetRegAdr(void);
ROBOTDLL_API int WINAPI GetIrqNo(void);
ROBOTDLL_API BOOL WINAPI SendCmdData(int iChNo, WORD wCmd, WORD wData);
ROBOTDLL_API BOOL WINAPI SendCmd(int iChNo, WORD wCmd);


ROBOTDLL_API BOOL WINAPI ReadData(WORD *pwData, int nNum);

ROBOTDLL_API BOOL WINAPI AdReadData(int ch, int *nAdData);
ROBOTDLL_API BOOL WINAPI AdCheckData(int ch, int *nAdData);

ROBOTDLL_API BOOL WINAPI DaWriteData(int ch, int nDAData);
ROBOTDLL_API BOOL WINAPI DaCheckData(int ch, int *nDaData);

ROBOTDLL_API BOOL WINAPI EncStart(int ch);
ROBOTDLL_API BOOL WINAPI EncStop(int ch);
ROBOTDLL_API BOOL WINAPI EncClear(int ch);
ROBOTDLL_API BOOL WINAPI EncRead(int ch, PDWORD puiEncData);
ROBOTDLL_API BOOL WINAPI EncSetMode(int ch, UINT iEncMode);
ROBOTDLL_API BOOL WINAPI EncWrite(int ch, DWORD dwData);
ROBOTDLL_API BOOL WINAPI EncZPhase(int ch, BOOL bPhase);
ROBOTDLL_API BOOL WINAPI EncZPole(BOOL bPole);

ROBOTDLL_API BOOL WINAPI StartTimer(int ch, WORD wMiliSec);
ROBOTDLL_API BOOL WINAPI StopTimer(int ch);
ROBOTDLL_API BOOL WINAPI IntEnable(int ch);
ROBOTDLL_API BOOL WINAPI IntDisable(int ch);
ROBOTDLL_API BOOL WINAPI IntMode(int ch, int mode);

ROBOTDLL_API BOOL WINAPI PioSet(int ch, BOOL bSet);
ROBOTDLL_API BOOL WINAPI PioRead(int iGroup, WORD *wPioData);
ROBOTDLL_API BOOL WINAPI PioWrite(int ch, WORD wPioData);

// Duty is not supported in standard PCI version(v1.00)
ROBOTDLL_API BOOL WINAPI PwmStart(int ch, BYTE byDuty);	//Duty is only 
ROBOTDLL_API BOOL WINAPI PwmStop(int ch);
ROBOTDLL_API BOOL WINAPI PwmSetClock(int ch, UINT uiClk);

ROBOTDLL_API int WINAPI GetWait1msLoops(int iMode, int IoAdr);

ROBOTDLL_API int WINAPI GetPciBaseAdr(int iRibNo);
ROBOTDLL_API int WINAPI GetPciBaseLCR(int iRibNo);

ROBOTDLL_API BOOL WINAPI	GetRibInfoEx(int iRibNo, PJWRIBPCI_DEV_INFO);

ROBOTDLL_API HANDLE WINAPI GetVxdHandle(void);
ROBOTDLL_API BOOL WINAPI MpuTest(void);
ROBOTDLL_API BOOL WINAPI MpuTestEx(int iRibNo);
ROBOTDLL_API BOOL WINAPI MpuReset(void);
ROBOTDLL_API BOOL WINAPI MpuResetEx(int iRibNo);

#ifdef	__cplusplus
}	//extern "C"
#endif	//__cplusplus

#endif	//__JWRIBDEF_H__
