// RobotCtrlDlg.h : header file
//

#include "RobotAdDaDlg.h"
#include "RobotPwmEncDlg.h"
#include "RobotPioDlg.h"
#include "RobotTimIntDlg.h"
#include "RobotMiscDlg.h"
#if !defined(AFX_ROBOTCTRLDLG_H__70D65D06_BC3D_11D3_BD57_0090CCA1478A__INCLUDED_)
#define AFX_ROBOTCTRLDLG_H__70D65D06_BC3D_11D3_BD57_0090CCA1478A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CRobotCtrlDlg dialog

class CRobotCtrlDlg : public CDialog
{
// Construction
public:
	CRobotCtrlDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRobotCtrlDlg)
	enum { IDD = IDD_ROBOTCTRL_DIALOG };
	CEdit	m_StaLEdit;
	CEdit	m_StaHEdit;
	UINT	m_nPcIrqNum;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRobotCtrlDlg)
	public:
	virtual BOOL DestroyWindow();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CRobotCtrlDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAdDa();
	afx_msg void OnPwmEnc();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPio();
	afx_msg void OnReset();
	afx_msg void OnMisc();
	afx_msg void OnKillfocusCmdadredit();
	afx_msg void OnKillfocusPcirqnumedit();
	afx_msg void OnMpuTest();
	afx_msg void OnInttimbutton();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	virtual void OnCancel();
	afx_msg void OnKillFocusRibIDEdit();
	afx_msg void OnKillFocusRibNoEdit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	UINT m_uiTimerId;
	void UpdateStatus();
	void RibInitial();
	//BOOL m_bAdDaDlg;
	//BOOL m_bPwmEncDlg;
	//BOOL m_bPioDlg;
	CRobotAdDaDlg *pRobotAdDaDlg;
	CRobotPwmEncDlg *pRobotPwmEncDlg;
	CRobotPioDlg *pRobotPioDlg;
	CRobotTimIntDlg *pRobotTimIntDlg;
	CRobotMiscDlg *pRobotMiscDlg;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROBOTCTRLDLG_H__70D65D06_BC3D_11D3_BD57_0090CCA1478A__INCLUDED_)
