// RobotMiscDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RobotCtrl.h"
#include "RobotMiscDlg.h"


#include <largeint.h>
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//EXTERN_DECLARE_RIB_PCI_BASEADR;

WORD ReadAdData(WORD iRibNo, WORD ch);

extern UINT WM_IrqMsg;
/////////////////////////////////////////////////////////////////////////////
char *ConvertWordToBinStr(WORD data, char* str)
{
	int i, tmp;
	for (i=15, tmp=data; i>=0; i--, tmp>>=1)
		str[i]=(tmp&0x01)+'0';
	str[16]=0;
	return str;
}
/////////////////////////////////////////////////////////////////////////////
// CRobotMiscDlg dialog


CRobotMiscDlg::CRobotMiscDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRobotMiscDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRobotMiscDlg)
	m_iDaCh = 0;
	m_nDaDigData = 0;
	m_bStartDaAuto = FALSE;
	m_vDaVolt = 0.0;
	m_uiTestLoop = 1000;
	m_iTestItem = 0;
	//}}AFX_DATA_INIT
	m_bInitialized = FALSE;
}


void CRobotMiscDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRobotMiscDlg)
	DDX_Control(pDX, IDC_DADATAEDIT, m_DaDataEdit);
	DDX_Control(pDX, IDC_ADDATAEDIT, m_AdDataEdit);
	DDX_Control(pDX, IDC_STATUSEDIT, m_StatusEdit);
	DDX_Control(pDX, IDC_AUTODATESTCHECK, m_DaTestCheck);
	DDX_Control(pDX, IDC_DATESTLOOP, m_DaTestLoopEdit);
	DDX_Control(pDX, IDC_DATIMELAPSE, m_DaTimeEdit);
	DDX_Control(pDX, IDC_DACHECK14, m_DaCheck14);
	DDX_Control(pDX, IDC_DACHECK13, m_DaCheck13);
	DDX_Control(pDX, IDC_DACHECK12, m_DaCheck12);
	DDX_Control(pDX, IDC_DACHECK11, m_DaCheck11);
	DDX_Control(pDX, IDC_DACHECK10, m_DaCheck10);
	DDX_Control(pDX, IDC_DACHECK9, m_DaCheck9);
	DDX_Control(pDX, IDC_DACHECK8, m_DaCheck8);
	DDX_Control(pDX, IDC_DACHECK7, m_DaCheck7);
	DDX_Control(pDX, IDC_DACHECK6, m_DaCheck6);
	DDX_Control(pDX, IDC_DACHECK5, m_DaCheck5);
	DDX_Control(pDX, IDC_DACHECK4, m_DaCheck4);
	DDX_Control(pDX, IDC_DACHECK3, m_DaCheck3);
	DDX_Control(pDX, IDC_DACHECK2, m_DaCheck2);
	DDX_Control(pDX, IDC_DACHECK15, m_DaCheck15);
	DDX_Control(pDX, IDC_DACHECK1, m_DaCheck1);
	DDX_Control(pDX, IDC_DACHECK0, m_DaCheck0);
	DDX_Control(pDX, IDC_DAVOLTEDIT, m_DaVoltEdit);
	DDX_Control(pDX, IDC_DADIGDATAEDIT, m_DaDigEdit);
	DDX_Control(pDX, IDC_DACHCOMBO, m_DaChCombo);
	DDX_CBIndex(pDX, IDC_DACHCOMBO, m_iDaCh);
	DDX_Text(pDX, IDC_DADIGDATAEDIT, m_nDaDigData);
	DDX_Check(pDX, IDC_AUTODATESTCHECK, m_bStartDaAuto);
	DDX_Text(pDX, IDC_DAVOLTEDIT, m_vDaVolt);
//	DDV_MinMaxDouble(pDX, m_vDaVolt, -10., 10.);
	DDX_Text(pDX, IDC_DATESTLOOP, m_uiTestLoop);
	DDV_MinMaxUInt(pDX, m_uiTestLoop, 0, 100000000);
	DDX_CBIndex(pDX, IDC_TESTITEMCOMBO, m_iTestItem);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRobotMiscDlg, CDialog)
	//{{AFX_MSG_MAP(CRobotMiscDlg)
	ON_BN_CLICKED(IDC_AUTODATESTCHECK, OnAutodatestcheck)
	ON_CBN_SELCHANGE(IDC_DACHCOMBO, OnSelchangeDachcombo)
	ON_WM_VSCROLL()
	ON_EN_KILLFOCUS(IDC_DADIGDATAEDIT, OnKillfocusDadigdataedit)
	ON_EN_KILLFOCUS(IDC_DAVOLTEDIT, OnKillfocusDavoltedit)
	ON_WM_HSCROLL()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_GETSTATUS, OnGetstatus)
	ON_BN_CLICKED(IDC_STARTAUTOADCHECK, OnStartautoad)
	ON_BN_CLICKED(IDC_STARTAUTODACHECK, OnStartautodacheck)
	ON_BN_CLICKED(IDC_ClearINTFLAG, OnClearINTFLAG)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRobotMiscDlg message handlers

void CRobotMiscDlg::OnSelchangeDachcombo() 
{
	m_iDaCh = m_DaChCombo.GetCurSel();
}
/*
void CRobotMiscDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
	if ((CSliderCtrl*)pScrollBar == &m_DaSlider)
		OnDaSlider();
}
*/

void CRobotMiscDlg::OnKillfocusDadigdataedit()
{
	char sBuf[32];

	if (UpdateData())
	{
//		if ( m_nDaDigData != m_DaSlider.GetPos() )
		{
//			m_DaSlider.SetPos(m_nDaDigData);
			m_vDaVolt = m_nDaDigData/2048.0*10.00;
			sprintf(sBuf, "%8.3f", m_vDaVolt);
			m_DaVoltEdit.SetWindowText(sBuf);
		}
	}
}

void CRobotMiscDlg::OnKillfocusDavoltedit()
{
	int nCurData;
	char sBuf[32];

	if (UpdateData())
	{
		nCurData = int( min( m_vDaVolt/10.0*2048+0.5, DAMAXVAL ) );
		if (nCurData!=m_nDaDigData)
		{
			m_nDaDigData = nCurData;
			m_DaDigEdit.SetWindowText(_itoa(nCurData, sBuf, 10));
//			m_DaSlider.SetPos(nCurData);
		}
		m_vDaVolt = nCurData/2048.0*10.00;
		sprintf(sBuf, "%8.3f", m_vDaVolt);
		m_DaVoltEdit.SetWindowText(sBuf);
	}
}

void CRobotMiscDlg::DlgIni()
{
	int nTicFreq;

	nTicFreq = (DAMAXVAL-DAMINVAL+1)/8;
//	m_DaSlider.SetRange(DAMINVAL, DAMAXVAL);
//	m_DaSlider.SetTicFreq(nTicFreq);
//	m_DaSlider.SetPageSize(nTicFreq/2);
//	m_DaSlider.SetLineSize(1);
//	m_DaSlider.SetPos(0);

	m_nDaDigData=0;
	m_DaDigEdit.SetLimitText(5);
	m_DaDigEdit.SetWindowText("0");

	m_vDaVolt=0.0;
	m_DaVoltEdit.SetLimitText(9);
	m_DaVoltEdit.SetWindowText("0.000");

	m_iDaCh=0;
	m_DaChCombo.SetCurSel(m_iDaCh);

	memset(m_abDaCheck, 0, sizeof(m_abDaCheck));
	CButton **ppButton;
	ppButton=m_apDaCheck;
	*(ppButton++)=&m_DaCheck0;  *(ppButton++)=&m_DaCheck1;  *(ppButton++)=&m_DaCheck2;  *(ppButton++)=&m_DaCheck3;
	*(ppButton++)=&m_DaCheck4;  *(ppButton++)=&m_DaCheck5;  *(ppButton++)=&m_DaCheck6;  *(ppButton++)=&m_DaCheck7;
	*(ppButton++)=&m_DaCheck8;  *(ppButton++)=&m_DaCheck9;  *(ppButton++)=&m_DaCheck10; *(ppButton++)=&m_DaCheck11;
	*(ppButton++)=&m_DaCheck12; *(ppButton++)=&m_DaCheck13; *(ppButton++)=&m_DaCheck14; *(ppButton++)=&m_DaCheck15;

	m_DaTestLoopEdit.SetLimitText(10);
	m_bAutoAd=FALSE;
	m_bAutoDa=FALSE;

	////
}

BOOL CRobotMiscDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	DlgIni();
	m_bInitialized = TRUE;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
/*
void CRobotMiscDlg::OnDaSlider()
{
	int nCurData;
	char sBuf[32];

//	nCurData = m_DaSlider.GetPos();
//	if (DaWriteData(m_iDaCh, nCurData))
	{
		if (m_nDaDigData!=nCurData)
		{
			m_nDaDigData=nCurData;
			m_DaDigEdit.SetWindowText(_itoa(nCurData, sBuf, 10));
			m_vDaVolt = nCurData/2048.0*10.00;
			sprintf(sBuf, "%8.3f", m_vDaVolt);
			m_DaVoltEdit.SetWindowText(sBuf);
		}
	}
}
*/
/*
void CRobotMiscDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if ((CSliderCtrl*)pScrollBar == &m_DaSlider)
		OnDaSlider();

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
*/
BOOL CRobotMiscDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	int i;
	for (i=0; (i<RIB_MAXDACH) && m_bInitialized ; i++)
		if ( (m_apDaCheck[i]->m_hWnd==HWND(lParam)) && !(wParam>>16) )
		{
			OnDaCheck(i);
			break;
		}
	
	return CDialog::OnCommand(wParam, lParam);
}

void CRobotMiscDlg::OnDaCheck(int ch)
{
	m_abDaCheck[ch] ^= TRUE;
}
void CRobotMiscDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	m_bInitialized = FALSE;
}


void CRobotMiscDlg::OnAutodatestcheck() 
{
	int err=0;
	BOOL bOk=TRUE;
	int nData=0;
	//int j;
	UINT nCount=0;
	int nDaData=4000;
	int i=0;
	int	ch;
	int	nSum=0;

	LARGE_INTEGER starthp, finishhp, clkpersechp;
	double duration;
	char str[64];

	ch = ((CComboBox*)GetDlgItem(IDC_MISC_CHCMB))->GetCurSel();
	if (ch>=16)
	{	MessageBox("ch value not correct.");
		return;
	}
	nDaData = GetDlgItemInt(IDC_DADIGDATAEDIT);

	SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);

	m_DaTestCheck.EnableWindow(FALSE);
	QueryPerformanceFrequency(&clkpersechp);
	Sleep(500);

	nData=-1024;
	if (UpdateData())
	{
		nData=0;

		SendCmdDataEx(0, ch, CMD_DA_WRITE, nDaData);
		//SendCmdDataEx(0, 8, CMD_DA_WRITE, nDaData);

		//	//	//	////	//	//	////	//	//	////	//	//	//
		QueryPerformanceCounter(&starthp);
		for (nCount=0, bOk=TRUE; (nCount<m_uiTestLoop) && !(err); nCount++)
		{
			switch(m_iTestItem)
			{
			case 0:							// AD_READ
				//if (!SendCmd(0, CMD_AD_READ))
				/*
				if ((nData=ReadAdData(0, 7))==(WORD)-1)
				{
					err = 1;
					break;
				}
				if (abs(nData-nDaData)>20)
				{
					err = 2;
					break;
				}
				*/
				///*
				if ((nData=ReadAdData(0, ch))==(WORD)-1)
				{
					err = 3;
					break;
				}
				if (abs(nData-nDaData)>20)
				{
					err = 2;
					break;
				}
				nSum += nData-nDaData;
				//*/
				break;

			case 1:							// DA_WRITE
				SendCmdDataEx(0, 0, CMD_DA_WRITE, nDaData);
				break;

			case 2:							// ENC_READ
				SendCmd(0, CMD_ENC_READ);
				break;
	 		}
		}
		QueryPerformanceCounter(&finishhp);

		wsprintf(str, "nCount=%i", nCount);
		SetDlgItemText(IDC_DATIMESTART, str);
		wsprintf(str, "err=%i", err);
		SetDlgItemText(IDC_DATIMESTOP, str);

		finishhp = LargeIntegerSubtract(finishhp, starthp);
		duration = double(finishhp.QuadPart)/double(clkpersechp.QuadPart)*1000.00;
		sprintf(str, "%10.4fms", duration);
		SetDlgItemText(IDC_DATIMELAPSE, str);

		if (err)
		{
			wsprintf(str, "error.\nabnormal quit @%d.", nCount);
			MessageBox(str);

			wsprintf(str, "nData=%i, nDaData=%i", nData, nDaData);
			SetDlgItemText(IDC_MISC_LOG3, str);
		}
		else
		{
			sprintf(str, "avg=%f", ((double)nSum) / m_uiTestLoop);
			SetDlgItemText(IDC_MISC_LOG3, str);
		}
	}
	else
	{
		SetDlgItemText(IDC_DATIMELAPSE, "0.#");
	}
	
	m_DaTestCheck.SetCheck(0);
	m_DaTestCheck.EnableWindow();
	m_DaTestCheck.SetFocus();

	SetPriorityClass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
}


void CRobotMiscDlg::OnGetstatus() 
{
}


void CRobotMiscDlg::OnStartautoad() 
{
}
void CRobotMiscDlg::OnStartautodacheck() 
{
}

void CRobotMiscDlg::OnAutoAdRead()
{
}

LRESULT CRobotMiscDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	return CDialog::WindowProc(message, wParam, lParam);
}

void CRobotMiscDlg::OnAutoDaWrite()
{
}

void CRobotMiscDlg::OnClearINTFLAG() 
{
	SendCmdEx(0, 0, CMD_INT_CLEAR);	
}

WORD ReadAdData(WORD iRibNo, WORD ch)		//0-4095  (not -2048 -- 2047)
{
	WORD wAdData;

	if (!SendCmdEx(0, ch, CMD_AD_READ))
		return -1;
	if (!ReadDataEx(0, &wAdData, 1))
		return -1;
	wAdData = wAdData&0x0FFF;

	return wAdData;
}

