#if !defined(AFX_ROBOTPIODLG_H__58EA7E26_BC73_11D3_BD57_0090CCA1478A__INCLUDED_)
#define AFX_ROBOTPIODLG_H__58EA7E26_BC73_11D3_BD57_0090CCA1478A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RobotPioDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRobotPioDlg dialog

class CRobotPioDlg : public CDialog
{
// Construction
public:
	void UpdateMpuData();
	CRobotPioDlg(CWnd* pParent = NULL);   // standard constructor

	BOOL m_bInitialized;

// Dialog Data
	//{{AFX_DATA(CRobotPioDlg)
	enum { IDD = IDD_PIO_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRobotPioDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CRobotPioDlg)
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnDestroy();
	afx_msg void OnPioManualTest();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void OnPioOutRadio(int ch);
	void UpdatePioIn();
	void DlgInitial();

	CButton *m_apPioInCheck	[64];
	int m_aiPioInCheckID	[64];
	int m_aiPioOutRadioID	[64];
	BOOL m_abPioInLevel		[64];
	BOOL m_abPioOutLevel	[64];
	/*CButton *m_apPioInCheck	[RIB_MAXPIOINCH];
	int m_aiPioInCheckID	[RIB_MAXPIOINCH];
	int m_aiPioOutRadioID	[RIB_MAXPIOOUTCH];
	BOOL m_abPioInLevel		[RIB_MAXPIOINCH];
	BOOL m_abPioOutLevel	[RIB_MAXPIOOUTCH];*/
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROBOTPIODLG_H__58EA7E26_BC73_11D3_BD57_0090CCA1478A__INCLUDED_)
