// RobotPwmEncDlg.cpp : implementation file
//
#include "stdafx.h"
#include "RobotCtrl.h"
#include "RobotPwmEncDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifndef JWRIBPCI_HARDWARE_VERSION
#error JWRIBPCI_HARDWARE_VERSION must be defined.
#endif

/////////////////////////////////////////////////////////////////////////////
// CRobotPwmEncDlg dialog
BOOL GetPwmRateString(LPSTR szBuf, int nSize, int PwmD);


CRobotPwmEncDlg::CRobotPwmEncDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRobotPwmEncDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRobotPwmEncDlg)
	m_uiPwmDuty0 = 0;
	m_uiPwmDuty1 = 0;
	m_uiPwmDuty2 = 0;
	m_uiPwmDuty3 = 0;
	m_uiPwmDuty4 = 0;
	m_uiPwmDuty5 = 0;
	m_uiPwmDuty6 = 0;
	m_uiPwmDuty7 = 0;
	m_uiPwmDuty8 = 0;
	m_uiPwmDuty9 = 0;
	m_uiPwmDuty10 = 0;
	m_uiPwmDuty11 = 0;
	m_uiPwmDuty12 = 0;
	m_uiPwmDuty13 = 0;
	m_uiPwmDuty14 = 0;
	m_uiPwmDuty15 = 0;
	m_uiPwmRate0 = 0;
	m_uiPwmRate1 = 0;
	m_uiPwmRate3 = 0;
	m_uiPwmRate2 = 0;
	//}}AFX_DATA_INIT

	m_iEncCurHis = 0;
	QueryPerformanceFrequency(&m_liFreq);
	m_bInitialized = FALSE;
}


void CRobotPwmEncDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRobotPwmEncDlg)
	DDX_Control(pDX, IDC_PWMRATEDEDIT3, m_PwmRateDEdit3);
	DDX_Control(pDX, IDC_PWMRATEDEDIT2, m_PwmRateDEdit2);
	DDX_Control(pDX, IDC_PWMRATEDEDIT1, m_PwmRateDEdit1);
	DDX_Control(pDX, IDC_PWMRATEDEDIT0, m_PwmRateDEdit0);
	DDX_Control(pDX, IDC_PWMSLIDER3, m_PwmSlider3);
	DDX_Control(pDX, IDC_PWMSLIDER2, m_PwmSlider2);
	DDX_Control(pDX, IDC_PWMSLIDER1, m_PwmSlider1);
	DDX_Control(pDX, IDC_PWMSLIDER0, m_PwmSlider0);
	DDX_Control(pDX, IDC_PWMRATEHZTEXT3, m_PwmHzStatic3);
	DDX_Control(pDX, IDC_PWMRATEHZTEXT2, m_PwmHzStatic2);
	DDX_Control(pDX, IDC_PWMRATEHZTEXT1, m_PwmHzStatic1);
	DDX_Control(pDX, IDC_PWMRATEHZTEXT0, m_PwmHzStatic0);
	DDX_Text(pDX, IDC_PWMDUTYEDIT0, m_uiPwmDuty0);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty0, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT1, m_uiPwmDuty1);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty1, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT2, m_uiPwmDuty2);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty2, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT3, m_uiPwmDuty3);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty3, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT4, m_uiPwmDuty4);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty4, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT5, m_uiPwmDuty5);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty5, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT6, m_uiPwmDuty6);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty6, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT7, m_uiPwmDuty7);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty7, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT8, m_uiPwmDuty8);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty8, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT9, m_uiPwmDuty9);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty9, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT10, m_uiPwmDuty10);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty10, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT11, m_uiPwmDuty11);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty11, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT12, m_uiPwmDuty12);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty12, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT13, m_uiPwmDuty13);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty13, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT14, m_uiPwmDuty14);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty14, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMDUTYEDIT15, m_uiPwmDuty15);
	DDV_MinMaxUInt(pDX, m_uiPwmDuty15, 0, PWMMAXDUTY);
	DDX_Text(pDX, IDC_PWMRATEDEDIT0, m_uiPwmRate0);
	DDV_MinMaxUInt(pDX, m_uiPwmRate0, 0, PWMMAXRATEDVAL);
	DDX_Text(pDX, IDC_PWMRATEDEDIT1, m_uiPwmRate1);
	DDV_MinMaxUInt(pDX, m_uiPwmRate1, 0, PWMMAXRATEDVAL);
	DDX_Text(pDX, IDC_PWMRATEDEDIT3, m_uiPwmRate3);
	DDV_MinMaxUInt(pDX, m_uiPwmRate3, 0, PWMMAXRATEDVAL);
	DDX_Text(pDX, IDC_PWMRATEDEDIT2, m_uiPwmRate2);
	DDV_MinMaxUInt(pDX, m_uiPwmRate2, 0, PWMMAXRATEDVAL);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRobotPwmEncDlg, CDialog)
	//{{AFX_MSG_MAP(CRobotPwmEncDlg)
	ON_BN_CLICKED(IDC_PWMCHECK0, OnPwmcheck0)
	ON_BN_CLICKED(IDC_PWMCHECK1, OnPwmcheck1)
	ON_BN_CLICKED(IDC_PWMCHECK2, OnPwmcheck2)
	ON_BN_CLICKED(IDC_PWMCHECK3, OnPwmcheck3)
	ON_BN_CLICKED(IDC_PWMCHECK4, OnPwmcheck4)
	ON_BN_CLICKED(IDC_PWMCHECK5, OnPwmcheck5)
	ON_BN_CLICKED(IDC_PWMCHECK6, OnPwmcheck6)
	ON_BN_CLICKED(IDC_PWMCHECK7, OnPwmcheck7)
	ON_BN_CLICKED(IDC_PWMCHECK8, OnPwmcheck8)
	ON_BN_CLICKED(IDC_PWMCHECK9, OnPwmcheck9)
	ON_BN_CLICKED(IDC_PWMCHECK10, OnPwmcheck10)
	ON_BN_CLICKED(IDC_PWMCHECK11, OnPwmcheck11)
	ON_BN_CLICKED(IDC_PWMCHECK12, OnPwmcheck12)
	ON_BN_CLICKED(IDC_PWMCHECK13, OnPwmcheck13)
	ON_BN_CLICKED(IDC_PWMCHECK14, OnPwmcheck14)
	ON_BN_CLICKED(IDC_PWMCHECK15, OnPwmcheck15)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT0, OnKillfocusPwmdutyedit0)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT1, OnKillfocusPwmdutyedit1)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT2, OnKillfocusPwmdutyedit2)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT3, OnKillfocusPwmdutyedit3)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT4, OnKillfocusPwmdutyedit4)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT5, OnKillfocusPwmdutyedit5)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT6, OnKillfocusPwmdutyedit6)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT7, OnKillfocusPwmdutyedit7)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT8, OnKillfocusPwmdutyedit8)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT9, OnKillfocusPwmdutyedit9)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT10, OnKillfocusPwmdutyedit10)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT11, OnKillfocusPwmdutyedit11)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT12, OnKillfocusPwmdutyedit12)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT13, OnKillfocusPwmdutyedit13)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT14, OnKillfocusPwmdutyedit14)
	ON_EN_KILLFOCUS(IDC_PWMDUTYEDIT15, OnKillfocusPwmdutyedit15)
	ON_EN_KILLFOCUS(IDC_PWMRATEDEDIT0, OnKillfocusPwmratededit0)
	ON_EN_KILLFOCUS(IDC_PWMRATEDEDIT1, OnKillfocusPwmratededit1)
	ON_EN_KILLFOCUS(IDC_PWMRATEDEDIT2, OnKillfocusPwmratededit2)
	ON_EN_KILLFOCUS(IDC_PWMRATEDEDIT3, OnKillfocusPwmratededit3)
	ON_WM_VSCROLL()
	ON_CBN_SELCHANGE(IDC_ENCCOMBO0, OnSelchangeEnccombo0)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO1, OnSelchangeEnccombo1)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO2, OnSelchangeEnccombo2)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO3, OnSelchangeEnccombo3)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO4, OnSelchangeEnccombo4)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO5, OnSelchangeEnccombo5)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO6, OnSelchangeEnccombo6)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO7, OnSelchangeEnccombo7)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO8, OnSelchangeEnccombo8)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO9, OnSelchangeEnccombo9)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO10, OnSelchangeEnccombo10)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO11, OnSelchangeEnccombo11)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO12, OnSelchangeEnccombo12)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO13, OnSelchangeEnccombo13)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO14, OnSelchangeEnccombo14)
	ON_CBN_SELCHANGE(IDC_ENCCOMBO15, OnSelchangeEnccombo15)
	ON_BN_CLICKED(IDC_ENCCHECK0, OnEnccheck0)
	ON_BN_CLICKED(IDC_ENCCHECK1, OnEnccheck1)
	ON_BN_CLICKED(IDC_ENCCHECK2, OnEnccheck2)
	ON_BN_CLICKED(IDC_ENCCHECK3, OnEnccheck3)
	ON_BN_CLICKED(IDC_ENCCHECK4, OnEnccheck4)
	ON_BN_CLICKED(IDC_ENCCHECK5, OnEnccheck5)
	ON_BN_CLICKED(IDC_ENCCHECK6, OnEnccheck6)
	ON_BN_CLICKED(IDC_ENCCHECK7, OnEnccheck7)
	ON_BN_CLICKED(IDC_ENCCHECK8, OnEnccheck8)
	ON_BN_CLICKED(IDC_ENCCHECK9, OnEnccheck9)
	ON_BN_CLICKED(IDC_ENCCHECK10, OnEnccheck10)
	ON_BN_CLICKED(IDC_ENCCHECK11, OnEnccheck11)
	ON_BN_CLICKED(IDC_ENCCHECK12, OnEnccheck12)
	ON_BN_CLICKED(IDC_ENCCHECK13, OnEnccheck13)
	ON_BN_CLICKED(IDC_ENCCHECK14, OnEnccheck14)
	ON_BN_CLICKED(IDC_ENCCHECK15, OnEnccheck15)
	ON_BN_CLICKED(IDC_ENCCLEAR0, OnEncclear0)
	ON_BN_CLICKED(IDC_ENCCLEAR1, OnEncclear1)
	ON_BN_CLICKED(IDC_ENCCLEAR10, OnEncclear10)
	ON_BN_CLICKED(IDC_ENCCLEAR11, OnEncclear11)
	ON_BN_CLICKED(IDC_ENCCLEAR12, OnEncclear12)
	ON_BN_CLICKED(IDC_ENCCLEAR13, OnEncclear13)
	ON_BN_CLICKED(IDC_ENCCLEAR14, OnEncclear14)
	ON_BN_CLICKED(IDC_ENCCLEAR15, OnEncclear15)
	ON_BN_CLICKED(IDC_ENCCLEAR2, OnEncclear2)
	ON_BN_CLICKED(IDC_ENCCLEAR3, OnEncclear3)
	ON_BN_CLICKED(IDC_ENCCLEAR4, OnEncclear4)
	ON_BN_CLICKED(IDC_ENCCLEAR5, OnEncclear5)
	ON_BN_CLICKED(IDC_ENCCLEAR6, OnEncclear6)
	ON_BN_CLICKED(IDC_ENCCLEAR7, OnEncclear7)
	ON_BN_CLICKED(IDC_ENCCLEAR8, OnEncclear8)
	ON_BN_CLICKED(IDC_ENCCLEAR9, OnEncclear9)
	ON_BN_CLICKED(IDC_ENCWRITE, OnEncWrite)
	ON_EN_SETFOCUS(IDC_ENCDATAWRITE, OnSetFocusEncDataWrite)
	ON_CBN_SELCHANGE(IDC_PWM_CH0, OnSelChangePwmCh00)
	ON_CBN_SELCHANGE(IDC_PWM_CH1, OnSelChangePwmCh01)
	ON_CBN_SELCHANGE(IDC_PWM_CH2, OnSelChangePwmCh02)
	ON_CBN_SELCHANGE(IDC_PWM_CH3, OnSelChangePwmCh03)
	ON_BN_CLICKED(IDC_ENC_ZPHASE00, OnEncZPhase00)
	ON_BN_CLICKED(IDC_ENC_ZPHASE01, OnEncZPhase01)
	ON_BN_CLICKED(IDC_ENC_ZPHASE02, OnEncZPhase02)
	ON_BN_CLICKED(IDC_ENC_ZPHASE03, OnEncZPhase03)
	ON_BN_CLICKED(IDC_ENC_ZPHASE04, OnEncZPhase04)
	ON_BN_CLICKED(IDC_ENC_ZPHASE05, OnEncZPhase05)
	ON_BN_CLICKED(IDC_ENC_ZPHASE06, OnEncZPhase06)
	ON_BN_CLICKED(IDC_ENC_ZPHASE07, OnEncZPhase07)
	ON_BN_CLICKED(IDC_ENC_ZPHASE08, OnEncZPhase08)
	ON_BN_CLICKED(IDC_ENC_ZPHASE09, OnEncZPhase09)
	ON_BN_CLICKED(IDC_ENC_ZPHASE10, OnEncZPhase10)
	ON_BN_CLICKED(IDC_ENC_ZPHASE11, OnEncZPhase11)
	ON_BN_CLICKED(IDC_ENC_ZPHASE12, OnEncZPhase12)
	ON_BN_CLICKED(IDC_ENC_ZPHASE13, OnEncZPhase13)
	ON_BN_CLICKED(IDC_ENC_ZPHASE14, OnEncZPhase14)
	ON_BN_CLICKED(IDC_ENC_ZPHASE15, OnEncZPhase15)
	ON_BN_CLICKED(IDC_ENC_ZPOLE, OnEncZPole)
	ON_BN_CLICKED(IDC_ENC_WRITE, OnEncWrite)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRobotPwmEncDlg message handlers

void CRobotPwmEncDlg::OnPwmcheck0() 
{
	OnPwmCheck(0);
}
void CRobotPwmEncDlg::OnPwmcheck1()
{
	OnPwmCheck(1);
}
void CRobotPwmEncDlg::OnPwmcheck2()
{
	OnPwmCheck(2);
}
void CRobotPwmEncDlg::OnPwmcheck3()
{
	OnPwmCheck(3);
}
void CRobotPwmEncDlg::OnPwmcheck4() 
{
	OnPwmCheck(4);
}
void CRobotPwmEncDlg::OnPwmcheck5() 
{
	OnPwmCheck(5);
}
void CRobotPwmEncDlg::OnPwmcheck6() 
{
	OnPwmCheck(6);
}
void CRobotPwmEncDlg::OnPwmcheck7() 
{
	OnPwmCheck(7);
}
void CRobotPwmEncDlg::OnPwmcheck8() 
{
	OnPwmCheck(8);
}
void CRobotPwmEncDlg::OnPwmcheck9() 
{
	OnPwmCheck(9);
}
void CRobotPwmEncDlg::OnPwmcheck10() 
{
	OnPwmCheck(10);
}
void CRobotPwmEncDlg::OnPwmcheck11() 
{
	OnPwmCheck(11);
}
void CRobotPwmEncDlg::OnPwmcheck12() 
{
	OnPwmCheck(12);
}
void CRobotPwmEncDlg::OnPwmcheck13() 
{
	OnPwmCheck(13);
}
void CRobotPwmEncDlg::OnPwmcheck14() 
{
	OnPwmCheck(14);
}
void CRobotPwmEncDlg::OnPwmcheck15() 
{
	OnPwmCheck(15);
}

void CRobotPwmEncDlg::OnKillfocusPwmdutyedit0() 
{
	OnKillFocusPwmDutyEdit(0);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit1() 
{
	OnKillFocusPwmDutyEdit(1);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit2() 
{
	OnKillFocusPwmDutyEdit(2);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit3() 
{
	OnKillFocusPwmDutyEdit(3);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit4() 
{
	OnKillFocusPwmDutyEdit(4);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit5() 
{
	OnKillFocusPwmDutyEdit(5);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit6() 
{
	OnKillFocusPwmDutyEdit(6);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit7() 
{
	OnKillFocusPwmDutyEdit(7);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit8() 
{
	OnKillFocusPwmDutyEdit(8);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit9() 
{
	OnKillFocusPwmDutyEdit(9);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit10() 
{
	OnKillFocusPwmDutyEdit(10);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit11() 
{
	OnKillFocusPwmDutyEdit(11);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit12() 
{
	OnKillFocusPwmDutyEdit(12);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit13() 
{
	OnKillFocusPwmDutyEdit(13);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit14() 
{
	OnKillFocusPwmDutyEdit(14);
}
void CRobotPwmEncDlg::OnKillfocusPwmdutyedit15() 
{
	OnKillFocusPwmDutyEdit(15);
}

void CRobotPwmEncDlg::OnKillfocusPwmratededit0() 
{
	OnKillFocusPwmRateDEdit(0);
}
void CRobotPwmEncDlg::OnKillfocusPwmratededit1() 
{
	OnKillFocusPwmRateDEdit(1);
}
void CRobotPwmEncDlg::OnKillfocusPwmratededit2() 
{
	OnKillFocusPwmRateDEdit(2);
}
void CRobotPwmEncDlg::OnKillfocusPwmratededit3() 
{
	OnKillFocusPwmRateDEdit(3);
}

void CRobotPwmEncDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	m_bInitialized = FALSE;

	CDialog::OnCancel();
}

void CRobotPwmEncDlg::OnOK() 
{
	// TODO: Add extra validation here
	m_bInitialized = FALSE;
	
	CDialog::OnOK();
}

void CRobotPwmEncDlg::OnKillFocusPwmDutyEdit(int ch)
{
#if (JWRIBPCI_HARDWARE_VERSION==0x0101) || (JWRIBPCI_HARDWARE_VERSION==0x0103) || (JWRIBPCI_HARDWARE_VERSION>=0x0200)
	if (ch>=RIB_MAXPWMCH)
		return;

	if (!UpdateData())
		return;
	if (m_auiPwmDuty[ch]==*m_apuiPwmDuty[ch])
		return;

	m_auiPwmDuty[ch]=*m_apuiPwmDuty[ch];
	//if (m_abPwmCheck[ch])
	{
		if (!SendCmdDataEx(0, ch, CMD_PWM_DUTY, m_auiPwmDuty[ch]))
			SetDlgItemText(IDC_ENC_DEBUG, "ERROR: SendCmdData!");
		else
		{
			char s[64];
			DWORD	dw;
			// for debug only
			ReadDWDataEx(0, &dw);
			wsprintf(s, "%08lX", dw);
			SetDlgItemText(IDC_ENC_DEBUG, s);
		}
	}
#endif//(JWRIBPCI_HARDWARE_VERSION==0x0101) || (JWRIBPCI_HARDWARE_VERSION==0x0103) || (JWRIBPCI_HARDWARE_VERSION>=0x0200)
}

void CRobotPwmEncDlg::OnPwmCheck(int ch)
{
	if (ch>=RIB_MAXPWMCH)
		return;
	m_abPwmCheck[ch]^=TRUE;
	if (m_abPwmCheck[ch])
	{
		char s[64];
		DWORD	dw;
		PwmStart(ch, m_auiPwmDuty[ch]);
		
		// for debug only
		ReadDWDataEx(0, &dw);
		wsprintf(s, "%08lX", dw);
		SetDlgItemText(IDC_ENC_DEBUG, s);
	}
	else
	{
		PwmStop(ch);
	}
}

void CRobotPwmEncDlg::OnKillFocusPwmRateDEdit(int ch)
{
	UINT uiRate=0;
	int iSubCh=((CComboBox*)GetDlgItem(IDC_PWM_CH0+ch))->GetCurSel();
	if ((ch*4+iSubCh)>=RIB_MAXPWMCH)
		return;

/*	uiRate = GetDlgItemInt(IDC_PWMRATEDEDIT0+ch, NULL, FALSE);
	if (uiRate>PWMMAXRATEDVAL)
	{
		m_apPwmRateDEdit[ch]->SetFocus();
		m_apPwmRateDEdit[ch]->SetSel(0, -1);
		return;
	}*/
	if(UpdateData())
	{
		if (*m_apuiPwmRateDVal[ch] != m_auiPwmRateDVal[ch*4+iSubCh])
		{
			m_auiPwmRateDVal[ch*4+iSubCh] = *m_apuiPwmRateDVal[ch];
			m_apPwmSlider[ch]->SetPos(m_auiPwmRateDVal[ch*4+iSubCh]);
			OnChangePwmRate(ch);
		}
	}
}

void CRobotPwmEncDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int ch;

	for(ch=0; (ch<(RIB_MAXPWMCH+3)/4) && ((CSliderCtrl*)pScrollBar!=m_apPwmSlider[ch]); ch++);
	if (ch<((RIB_MAXPWMCH+3)/4))
		OnPwmRateScroll(ch);

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CRobotPwmEncDlg::DlgInitial()
{
	int i;
	CSliderCtrl *pSlider;
	CSliderCtrl **ppSlider;
	CStatic **ppStatic;
	CEdit *pEdit;
	CEdit **ppEdit;
	CSpinButtonCtrl *pSpin;
	int *pInt;
	UINT **ppUInt;
	CComboBox *pCombo;
	int nTicFreq;
	CString	stmp;
	
	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//
	//	PWM controls initial
	pInt = m_aiPwmSliderID;
	*(pInt++)=IDC_PWMSLIDER0;	*(pInt++)=IDC_PWMSLIDER1;	*(pInt++)=IDC_PWMSLIDER2;	*(pInt++)=IDC_PWMSLIDER3;

	pInt = m_aiPwmRateDEditID;
	*(pInt++)=IDC_PWMRATEDEDIT0;*(pInt++)=IDC_PWMRATEDEDIT1;*(pInt++)=IDC_PWMRATEDEDIT2;*(pInt++)=IDC_PWMRATEDEDIT3;

	ppSlider=m_apPwmSlider;
	*(ppSlider++)=&m_PwmSlider0;	*(ppSlider++)=&m_PwmSlider1;  *(ppSlider++)=&m_PwmSlider2; *(ppSlider++)=&m_PwmSlider3;

	ppEdit=m_apPwmRateDEdit;
	*(ppEdit++)=&m_PwmRateDEdit0;	*(ppEdit++)=&m_PwmRateDEdit1;  *(ppEdit++)=&m_PwmRateDEdit2;  *(ppEdit++)=&m_PwmRateDEdit3;

	ppStatic=m_apPwmHzStatic;
	*(ppStatic++)=&m_PwmHzStatic0;	*(ppStatic++)=&m_PwmHzStatic1;  *(ppStatic++)=&m_PwmHzStatic2;	*(ppStatic++)=&m_PwmHzStatic3;

	ppUInt=m_apuiPwmRateDVal;
	*(ppUInt++)=&m_uiPwmRate0;	*(ppUInt++)=&m_uiPwmRate1;  *(ppUInt++)=&m_uiPwmRate2;	*(ppUInt++)=&m_uiPwmRate3;

	nTicFreq=(PWMMAXRATEDVAL-PWMMINRATEDVAL+1)/8;
	for (int nLimitText=0 , nTemp =PWMMAXRATEDVAL; nTemp>0; nLimitText++, nTemp/=10);
	char szPwmRate[16]={0};
	GetPwmRateString(szPwmRate, 16, 0);
	for (i=0; i<((RIB_MAXPWMCH+3)/4); i++)
	{
		//m_auiPwmRateDVal[i]=0;

		pSlider = (CSliderCtrl*)GetDlgItem(m_aiPwmSliderID[i]);
		m_apPwmSlider[i] = pSlider;
		pSlider->SetRange(PWMMINRATEDVAL, PWMMAXRATEDVAL);
		pSlider->SetTicFreq(nTicFreq);
		pSlider->SetPageSize(max(nTicFreq/2, 2));
		pSlider->SetLineSize(1);
		pSlider->SetPos(PWMMINRATEDVAL);

		pEdit = m_apPwmRateDEdit[i];
		pEdit->SetLimitText(nLimitText);
		m_apPwmHzStatic[i]->SetWindowTextA(szPwmRate);

		// Initialize Pwm Rate Channel Setting
		((CComboBox*)GetDlgItem(IDC_PWM_CH0+i))->SetCurSel(0);
	}

	pInt = m_aiPwmDutyEditID;
	*(pInt++)=IDC_PWMDUTYEDIT0;	*(pInt++)=IDC_PWMDUTYEDIT1;	*(pInt++)=IDC_PWMDUTYEDIT2;	*(pInt++)=IDC_PWMDUTYEDIT3;
	*(pInt++)=IDC_PWMDUTYEDIT4;	*(pInt++)=IDC_PWMDUTYEDIT5;	*(pInt++)=IDC_PWMDUTYEDIT6;	*(pInt++)=IDC_PWMDUTYEDIT7;
	*(pInt++)=IDC_PWMDUTYEDIT8;	*(pInt++)=IDC_PWMDUTYEDIT9;	*(pInt++)=IDC_PWMDUTYEDIT10;*(pInt++)=IDC_PWMDUTYEDIT11;
	*(pInt++)=IDC_PWMDUTYEDIT12;*(pInt++)=IDC_PWMDUTYEDIT13;*(pInt++)=IDC_PWMDUTYEDIT14;*(pInt++)=IDC_PWMDUTYEDIT15;

	pInt = m_aiPwmDutySpinID;
	*(pInt++)=IDC_PWMDUTYSPIN0;	*(pInt++)=IDC_PWMDUTYSPIN1;	*(pInt++)=IDC_PWMDUTYSPIN2;	*(pInt++)=IDC_PWMDUTYSPIN3;
	*(pInt++)=IDC_PWMDUTYSPIN4;	*(pInt++)=IDC_PWMDUTYSPIN5;	*(pInt++)=IDC_PWMDUTYSPIN6;	*(pInt++)=IDC_PWMDUTYSPIN7;
	*(pInt++)=IDC_PWMDUTYSPIN8;	*(pInt++)=IDC_PWMDUTYSPIN9;	*(pInt++)=IDC_PWMDUTYSPIN10;*(pInt++)=IDC_PWMDUTYSPIN11;
	*(pInt++)=IDC_PWMDUTYSPIN12;*(pInt++)=IDC_PWMDUTYSPIN13;*(pInt++)=IDC_PWMDUTYSPIN14;*(pInt++)=IDC_PWMDUTYSPIN15;

	ppUInt = m_apuiPwmDuty;
	*(ppUInt++)=&m_uiPwmDuty0 ;	*(ppUInt++)=&m_uiPwmDuty1 ;	*(ppUInt++)=&m_uiPwmDuty2 ;	*(ppUInt++)=&m_uiPwmDuty3 ;
	*(ppUInt++)=&m_uiPwmDuty4 ;	*(ppUInt++)=&m_uiPwmDuty5 ;	*(ppUInt++)=&m_uiPwmDuty6 ;	*(ppUInt++)=&m_uiPwmDuty7 ;
	*(ppUInt++)=&m_uiPwmDuty8 ;	*(ppUInt++)=&m_uiPwmDuty9 ;	*(ppUInt++)=&m_uiPwmDuty10;	*(ppUInt++)=&m_uiPwmDuty11;
	*(ppUInt++)=&m_uiPwmDuty12;	*(ppUInt++)=&m_uiPwmDuty13;	*(ppUInt++)=&m_uiPwmDuty14;	*(ppUInt++)=&m_uiPwmDuty15;

	for (i=0; i<RIB_MAXPWMCH; i++)
	{
		m_auiPwmRateDVal[i]=0;		//>>
		m_abPwmCheck[i] = FALSE;

		pEdit = (CEdit*)GetDlgItem(m_aiPwmDutyEditID[i]);
		m_apPwmDutyEdit[i] = pEdit;
		pEdit->SetLimitText(PWMMAXDUTY>1000?4:3);

		m_auiPwmDuty[i]=*m_apuiPwmDuty[i]=(PWMMAXDUTY+1)/2;
		pSpin = (CSpinButtonCtrl*)GetDlgItem(m_aiPwmDutySpinID[i]);
		pSpin->SetRange(PWMMINDUTY, PWMMAXDUTY);
		pSpin->SetBase(10);
		pSpin->SetPos((PWMMAXDUTY+1)/2);

		PwmStop(i);
		PwmSetClock(i, 0);

#if (JWRIBPCI_HARDWARE_VERSION==0x0101) || (JWRIBPCI_HARDWARE_VERSION==0x0103) || (JWRIBPCI_HARDWARE_VERSION>=0x0200)
		GetDlgItem(IDC_PWMDUTYEDIT0+i)->EnableWindow(TRUE);
		SendCmdDataEx(0, i, CMD_PWM_DUTY, (PWMMAXDUTY+1)/2);
#else
		GetDlgItem(IDC_PWMDUTYEDIT0+i)->EnableWindow(FALSE);
#endif
	}
#if RIB_MAXPWMCH<16
	for (i=RIB_MAXPWMCH; i<16; i++)
	{
		pEdit = (CEdit*)GetDlgItem(m_aiPwmDutyEditID[i]);
		pEdit->EnableWindow(FALSE);
		pSpin = (CSpinButtonCtrl*)GetDlgItem(m_aiPwmDutySpinID[i]);
		pSpin->EnableWindow(FALSE);
		GetDlgItem(IDC_PWMCHECK0+i)->EnableWindow(FALSE);
	}
#endif
	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//
	//	ENC controls initial
	pInt = m_aiEncEditID;
	(*pInt++)=IDC_ENCEDIT0;	(*pInt++)=IDC_ENCEDIT1;	(*pInt++)=IDC_ENCEDIT2;	(*pInt++)=IDC_ENCEDIT3;
	(*pInt++)=IDC_ENCEDIT4;	(*pInt++)=IDC_ENCEDIT5;	(*pInt++)=IDC_ENCEDIT6;	(*pInt++)=IDC_ENCEDIT7;
	(*pInt++)=IDC_ENCEDIT8;	(*pInt++)=IDC_ENCEDIT9;	(*pInt++)=IDC_ENCEDIT10;(*pInt++)=IDC_ENCEDIT11;
	(*pInt++)=IDC_ENCEDIT12;(*pInt++)=IDC_ENCEDIT13;(*pInt++)=IDC_ENCEDIT14;(*pInt++)=IDC_ENCEDIT15;
	pInt = m_aiEncComboID;
	(*pInt++)=IDC_ENCCOMBO0;	(*pInt++)=IDC_ENCCOMBO1;	(*pInt++)=IDC_ENCCOMBO2;	(*pInt++)=IDC_ENCCOMBO3;
	(*pInt++)=IDC_ENCCOMBO4;	(*pInt++)=IDC_ENCCOMBO5;	(*pInt++)=IDC_ENCCOMBO6;	(*pInt++)=IDC_ENCCOMBO7;
	(*pInt++)=IDC_ENCCOMBO8;	(*pInt++)=IDC_ENCCOMBO9;	(*pInt++)=IDC_ENCCOMBO10;	(*pInt++)=IDC_ENCCOMBO11;
	(*pInt++)=IDC_ENCCOMBO12;	(*pInt++)=IDC_ENCCOMBO13;	(*pInt++)=IDC_ENCCOMBO14;	(*pInt++)=IDC_ENCCOMBO15;
	/*pInt = m_aiEncAcCheckID;
	(*pInt++)=IDC_ENCACCHECK0;	(*pInt++)=IDC_ENCACCHECK1;	(*pInt++)=IDC_ENCACCHECK2;	(*pInt++)=IDC_ENCACCHECK3;
	(*pInt++)=IDC_ENCACCHECK4;	(*pInt++)=IDC_ENCACCHECK5;	(*pInt++)=IDC_ENCACCHECK6;	(*pInt++)=IDC_ENCACCHECK7;
	(*pInt++)=IDC_ENCACCHECK8;	(*pInt++)=IDC_ENCACCHECK9;	(*pInt++)=IDC_ENCACCHECK10;	(*pInt++)=IDC_ENCACCHECK11;
	(*pInt++)=IDC_ENCACCHECK12;	(*pInt++)=IDC_ENCACCHECK13;	(*pInt++)=IDC_ENCACCHECK14;	(*pInt++)=IDC_ENCACCHECK15;
	*/
	for (i=0; i<RIB_MAXENCCH; i++)
	{
		m_abEncCheck[i] = FALSE;

		pCombo = (CComboBox*)GetDlgItem(m_aiEncComboID[i]);
		m_apEncCombo[i] = pCombo;

#ifndef	_RIB_NO_ENC_INIT		// do initial
		m_aiEncMode[i]=0;					// Default: Pulse
		pCombo->SetCurSel(m_aiEncMode[i]);

		m_auiEncData[i]=0;
		SetDlgItemText(m_aiEncEditID[i], "0");
		SendCmdEx(0, i, CMD_ENC_CLEAR);
#else
		if(	EncRead(i, (DWORD*)(&m_auiEncData[i])))
		{
			stmp.Format("%06lX", m_auiEncData[i]);
			SetDlgItemText(m_aiEncEditID[i], stmp);
		}
		//SendCmdEx(0, i, CMD_ENC_CLEAR);
#endif
	}
	//SendCmdDataEx(0, CMD_ENC_ZPHASE, 0);


	InitEncSpeed(-1);
	m_iEncCurHis = 0;
	m_bShiftMode = FALSE;
	for (i=0; i<10; i++)
	{
		m_liEncTimeStamp[i].QuadPart = 0;
	}
}

void CRobotPwmEncDlg::OnPwmRateScroll(int ch)
{
	char szDVal[32];
	int iSubCh=((CComboBox*)GetDlgItem(IDC_PWM_CH0+ch))->GetCurSel();
	if ((ch*4+iSubCh)>=RIB_MAXPWMCH)
		return;

	m_auiPwmRateDVal[ch*4+iSubCh] = m_apPwmSlider[ch]->GetPos();
	if (m_auiPwmRateDVal[ch*4+iSubCh]!=*m_apuiPwmRateDVal[ch])
	{
		*m_apuiPwmRateDVal[ch] = m_auiPwmRateDVal[ch*4+iSubCh];
		m_apPwmRateDEdit[ch]->SetWindowText(_itoa(m_auiPwmRateDVal[ch*4+iSubCh], szDVal, 10));
		OnChangePwmRate(ch);
	}

}

BOOL CRobotPwmEncDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	DlgInitial();

	m_bInitialized = TRUE;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRobotPwmEncDlg::UpdateMpuData()
{
	UpdateEnc();
}


void CRobotPwmEncDlg::UpdateEnc()
{
	DWORD dwCurData, dwPrevData;
	int i;
	char szText[32];
	BOOL bCanCount=FALSE;
	LARGE_INTEGER liTime;
	double dblTime;
	LPDWORD	lpdw;
	long	dat;

	if (++m_iEncCurHis>=10)
		m_iEncCurHis = 0;

	liTime = m_liEncTimeStamp[m_iEncCurHis];
	QueryPerformanceCounter(&m_liEncTimeStamp[m_iEncCurHis]);
	liTime = LargeIntegerSubtract(m_liEncTimeStamp[m_iEncCurHis], liTime);
	lpdw = (LPDWORD)&liTime.QuadPart;
	dblTime = (double)lpdw[0] + (double)lpdw[1]*0xFFFFFFFF;
	lpdw = (LPDWORD)&m_liFreq.QuadPart;
	dblTime /= (double)lpdw[0] + (double)lpdw[1]*0xFFFFFFFF;

	for (i=0; i<RIB_MAXENCCH; i++)
	{
		if (!m_abEncCheck[i])	// enable?
			continue;
		if (!EncRead(i, &dwCurData))
			return;
		if (m_auiEncData[i]!=dwCurData)
		{
			m_auiEncData[i]=dwCurData;
			if (!m_bShiftMode)
				SetDlgItemText(m_aiEncEditID[i], _ultoa(dwCurData, szText, ENC_DISPLAY_BASE));
		}

		dwPrevData = m_adwEncDataHis[i][m_iEncCurHis];
		m_adwEncDataHis[i][m_iEncCurHis] = dwCurData;
		if (m_bEncHisInitCnt[i]<10)
		{
			m_bEncHisInitCnt[i]++;
			continue;
		}
		if (m_bShiftMode)
		{
			dat = (dwCurData - dwPrevData)&0xFFFFFF;
			if (dat&0x800000)
				dat |= 0xFF000000;
			dat = (int)(dat / dblTime);
			SetDlgItemText(m_aiEncEditID[i], _ltoa(dat, szText, 10));
		}
	}
}


void CRobotPwmEncDlg::OnChangePwmRate(int ch)
{
	char szPwmHzText[32];
	int iSubCh=((CComboBox*)GetDlgItem(IDC_PWM_CH0+ch))->GetCurSel();
	if ((ch*4+iSubCh)>=RIB_MAXPWMCH)
		return;

	//PwmRateHz = 62.500 / (16-m_auiPwmRateDVal[ch]);
	if ( GetPwmRateString(szPwmHzText, 32, m_auiPwmRateDVal[ch*4+iSubCh]) )
		m_apPwmHzStatic[ch]->SetWindowTextA(szPwmHzText);

#if JWRIBPCI_HARDWARE_VERSION==0x0102
	if (!SendCmdDWDataEx(0, ch*4+iSubCh, CMD_PWM_RATE, m_auiPwmRateDVal[ch*4+iSubCh]))
#else
	if (!PwmSetClock(ch*4+iSubCh, m_auiPwmRateDVal[ch*4+iSubCh]))
#endif
		SetDlgItemText(IDC_ENC_DEBUG, "ERROR: Set Pwm Clock!");
	else
	{
		char s[64];
		DWORD	dw;
		// for debug only
		ReadDWDataEx(0, &dw);
		wsprintf(s, "%08lX", dw);
		SetDlgItemText(IDC_ENC_DEBUG, s);
	}
}

//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	Enc Combo
void CRobotPwmEncDlg::OnSelchangeEnccombo0() 
{
	OnSelChangeEncCombo(0);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo1() 
{
	OnSelChangeEncCombo(1);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo2() 
{
	OnSelChangeEncCombo(2);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo3() 
{
	OnSelChangeEncCombo(3);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo4() 
{
	OnSelChangeEncCombo(4);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo5() 
{
	OnSelChangeEncCombo(5);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo6() 
{
	OnSelChangeEncCombo(6);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo7() 
{
	OnSelChangeEncCombo(7);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo8() 
{
	OnSelChangeEncCombo(8);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo9() 
{
	OnSelChangeEncCombo(9);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo10() 
{
	OnSelChangeEncCombo(10);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo11() 
{
	OnSelChangeEncCombo(11);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo12() 
{
	OnSelChangeEncCombo(12);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo13() 
{
	OnSelChangeEncCombo(13);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo14() 
{
	OnSelChangeEncCombo(14);
}
void CRobotPwmEncDlg::OnSelchangeEnccombo15() 
{
	OnSelChangeEncCombo(15);
}

//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	Enc Check
void CRobotPwmEncDlg::OnEnccheck0() 
{
	OnEncCheck(0);
}
void CRobotPwmEncDlg::OnEnccheck1() 
{
	OnEncCheck(1);
}
void CRobotPwmEncDlg::OnEnccheck2() 
{
	OnEncCheck(2);
}
void CRobotPwmEncDlg::OnEnccheck3() 
{
	OnEncCheck(3);
}
void CRobotPwmEncDlg::OnEnccheck4() 
{
	OnEncCheck(4);
}
void CRobotPwmEncDlg::OnEnccheck5() 
{
	OnEncCheck(5);
}
void CRobotPwmEncDlg::OnEnccheck6() 
{
	OnEncCheck(6);
}
void CRobotPwmEncDlg::OnEnccheck7() 
{
	OnEncCheck(7);
}
void CRobotPwmEncDlg::OnEnccheck8() 
{
	OnEncCheck(8);
}
void CRobotPwmEncDlg::OnEnccheck9() 
{
	OnEncCheck(9);
}
void CRobotPwmEncDlg::OnEnccheck10() 
{
	OnEncCheck(10);
}
void CRobotPwmEncDlg::OnEnccheck11() 
{
	OnEncCheck(11);
}
void CRobotPwmEncDlg::OnEnccheck12() 
{
	OnEncCheck(12);
}
void CRobotPwmEncDlg::OnEnccheck13() 
{
	OnEncCheck(13);
}
void CRobotPwmEncDlg::OnEnccheck14() 
{
	OnEncCheck(14);
}
void CRobotPwmEncDlg::OnEnccheck15() 
{
	OnEncCheck(15);
}

//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	EncClear
void CRobotPwmEncDlg::OnEncclear0() 
{
	OnEncClear(0);
}
void CRobotPwmEncDlg::OnEncclear1() 
{
	OnEncClear(1);
}
void CRobotPwmEncDlg::OnEncclear2() 
{
	OnEncClear(2);
}
void CRobotPwmEncDlg::OnEncclear3() 
{
	OnEncClear(3);
}
void CRobotPwmEncDlg::OnEncclear4() 
{
	OnEncClear(4);
}
void CRobotPwmEncDlg::OnEncclear5() 
{
	OnEncClear(5);
}
void CRobotPwmEncDlg::OnEncclear6() 
{
	OnEncClear(6);
}
void CRobotPwmEncDlg::OnEncclear7() 
{
	OnEncClear(7);
}
void CRobotPwmEncDlg::OnEncclear8() 
{
	OnEncClear(8);
}
void CRobotPwmEncDlg::OnEncclear9() 
{
	OnEncClear(9);
}
void CRobotPwmEncDlg::OnEncclear10() 
{
	OnEncClear(10);
}
void CRobotPwmEncDlg::OnEncclear11() 
{
	OnEncClear(11);
}
void CRobotPwmEncDlg::OnEncclear12() 
{
	OnEncClear(12);
}
void CRobotPwmEncDlg::OnEncclear13() 
{
	OnEncClear(13);
}
void CRobotPwmEncDlg::OnEncclear14() 
{
	OnEncClear(14);
}
void CRobotPwmEncDlg::OnEncclear15() 
{
	OnEncClear(15);
}



//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//
void CRobotPwmEncDlg::OnSelChangeEncCombo(int ch)
{
	int iSelMode;
	iSelMode = m_apEncCombo[ch]->GetCurSel();
	if (iSelMode!=m_aiEncMode[ch])
	{
		m_aiEncMode[ch] = iSelMode;
		EncSetMode(ch, iSelMode);
	}
}

void CRobotPwmEncDlg::OnEncClear(int ch)
{
	EncClear(ch);
	//EncWrite(ch, 0x00080000);
}

void CRobotPwmEncDlg::OnEncCheck(int ch)
{
	m_abEncCheck[ch]^=TRUE;
	if (m_abEncCheck[ch])
	{
		EncStart(ch);
	}
	else
	{
		EncStop(ch);
	}
}

/*
BOOL CRobotPwmEncDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	int i, id;
	for (i=0, id=wParam&0x0000FFFF; i<RIB_MAXENCCH; i++)
	{
		if (id==m_aiEncAcCheckID[i])
		{
			OnEncZPhase(i);
			return 0;
		}
	}
	
	return CDialog::OnCommand(wParam, lParam);
}

/*
void CRobotPwmEncDlg::OnEncZPhase(int ch)
{
	UINT uiData;
	int i;
	for (i=RIB_MAXENCCH-1, uiData=0; i>=0; i--, uiData<<=1)
	{
		uiData |= IsDlgButtonChecked(m_aiEncAcCheckID[i]);
	}
	uiData>>=1;

	SendCmdDataEx(0, 0, CMD_ENC_ZPHASE, uiData);
}
*/

void CRobotPwmEncDlg::OnEncWrite() 
{
	int	ch;
	DWORD	dw;
	CString	str;
	char	*endptr;

	ch = ((CComboBox*)GetDlgItem(IDC_ENC_CHWRITE))->GetCurSel();
	if (ch==CB_ERR)		return;
	if (ch == RIB_MAXENCCH)	ch=-1;
	//dw = GetDlgItemInt(IDC_ENCDATAWRITE, NULL, FALSE);
	if (!GetDlgItemText(IDC_ENC_DATAWRITE, str))
		return;
	dw = strtol(str, &endptr, ENC_DISPLAY_BASE);
	if (*endptr!=NULL)
	{
		SetDlgItemText(IDC_ENCDATAWRITE, "");
		return;
	}

	EncWrite(ch, dw);
}

void CRobotPwmEncDlg::OnSetFocusEncDataWrite() 
{
	CEdit *pedit=(CEdit*)GetDlgItem(IDC_ENCDATAWRITE);
	pedit->SetSel(0xFFFF0000);
}

void CRobotPwmEncDlg::OnSelChangePwmCh00() 
{
	OnSelChangePwmCh(0);
}
void CRobotPwmEncDlg::OnSelChangePwmCh01() 
{
	OnSelChangePwmCh(1);
}
void CRobotPwmEncDlg::OnSelChangePwmCh02() 
{
	OnSelChangePwmCh(2);
}
void CRobotPwmEncDlg::OnSelChangePwmCh03() 
{
	OnSelChangePwmCh(3);
}

void CRobotPwmEncDlg::OnSelChangePwmCh(int ch) 
{
	char szPwmRate[32];
	int iSubCh=((CComboBox*)GetDlgItem(IDC_PWM_CH0+ch))->GetCurSel();
	if ((ch*4+iSubCh)>=RIB_MAXPWMCH)
		return;

	SetDlgItemInt(m_aiPwmRateDEditID[ch], m_auiPwmRateDVal[ch*4+iSubCh], FALSE);
	*m_apuiPwmRateDVal[ch] = m_auiPwmRateDVal[ch*4+iSubCh];
	m_apPwmSlider[ch]->SetPos(m_auiPwmRateDVal[ch*4+iSubCh]);
	if ( GetPwmRateString(szPwmRate, 32, m_auiPwmRateDVal[ch*4+iSubCh]) )
		m_apPwmHzStatic[ch]->SetWindowText(szPwmRate);
}

BOOL GetPwmRateString(LPSTR szBuf, int nSize, int PwmD)
{
	double dblPwmRateHz;
	const char szUnit[4][4]={{"Hz"}, {"KHz"}, {"MHz"}, {"GHz"}};
	int	iUnit;

	if ( (PwmD<PWMMINRATEDVAL) || (PwmD>PWMMAXRATEDVAL) || (nSize<11) )
		return FALSE;

	dblPwmRateHz = RibGetPwmRate(PwmD);
	if (dblPwmRateHz<1000)
		iUnit=0;
	else if ((dblPwmRateHz/=1000)<1000)
		iUnit=1;
	else if ((dblPwmRateHz/=1000)<1000)
		iUnit=2;
	else
	{
		iUnit=3;
		dblPwmRateHz/=1000;
	}
	sprintf(szBuf, "%6.3f%s", dblPwmRateHz, szUnit[iUnit]);
	return TRUE;
}


void CRobotPwmEncDlg::OnEncZPhase(int i, BOOL bChecked) 
{
	char s[64];
	DWORD	dw;
	if (!EncZPhase(i, bChecked))
	{
		SetDlgItemText(IDC_ENC_DEBUG, "ERROR: SendCmdData!");
	}
	else
	{
		// for debug only
		ReadDWDataEx(0, &dw);
		wsprintf(s, "%08lX", dw);
		SetDlgItemText(IDC_ENC_DEBUG, s);
	}
}

void CRobotPwmEncDlg::OnEncZPhase00() 
{
	OnEncZPhase(0, IsDlgButtonChecked(IDC_ENC_ZPHASE00));
}
void CRobotPwmEncDlg::OnEncZPhase01() 
{
	OnEncZPhase(1, IsDlgButtonChecked(IDC_ENC_ZPHASE01));
}
void CRobotPwmEncDlg::OnEncZPhase02() 
{
	OnEncZPhase(2, IsDlgButtonChecked(IDC_ENC_ZPHASE02));
}
void CRobotPwmEncDlg::OnEncZPhase03() 
{
	OnEncZPhase(3, IsDlgButtonChecked(IDC_ENC_ZPHASE03));
}
void CRobotPwmEncDlg::OnEncZPhase04() 
{
	OnEncZPhase(4, IsDlgButtonChecked(IDC_ENC_ZPHASE04));
}
void CRobotPwmEncDlg::OnEncZPhase05() 
{
	OnEncZPhase(5, IsDlgButtonChecked(IDC_ENC_ZPHASE05));
}
void CRobotPwmEncDlg::OnEncZPhase06() 
{
	OnEncZPhase(6, IsDlgButtonChecked(IDC_ENC_ZPHASE06));
}
void CRobotPwmEncDlg::OnEncZPhase07() 
{
	OnEncZPhase(7, IsDlgButtonChecked(IDC_ENC_ZPHASE07));
}
void CRobotPwmEncDlg::OnEncZPhase08() 
{
	OnEncZPhase(8, IsDlgButtonChecked(IDC_ENC_ZPHASE08));
}
void CRobotPwmEncDlg::OnEncZPhase09() 
{
	OnEncZPhase(9, IsDlgButtonChecked(IDC_ENC_ZPHASE09));
}
void CRobotPwmEncDlg::OnEncZPhase10() 
{
	OnEncZPhase(10, IsDlgButtonChecked(IDC_ENC_ZPHASE10));
}
void CRobotPwmEncDlg::OnEncZPhase11() 
{
	OnEncZPhase(11, IsDlgButtonChecked(IDC_ENC_ZPHASE11));
}
void CRobotPwmEncDlg::OnEncZPhase12() 
{
	OnEncZPhase(12, IsDlgButtonChecked(IDC_ENC_ZPHASE12));
}
void CRobotPwmEncDlg::OnEncZPhase13() 
{
	OnEncZPhase(13, IsDlgButtonChecked(IDC_ENC_ZPHASE13));
}
void CRobotPwmEncDlg::OnEncZPhase14() 
{
	OnEncZPhase(14, IsDlgButtonChecked(IDC_ENC_ZPHASE14));
}
void CRobotPwmEncDlg::OnEncZPhase15() 
{
	OnEncZPhase(15, IsDlgButtonChecked(IDC_ENC_ZPHASE15));
}

void CRobotPwmEncDlg::OnEncZPole() 
{
	char s[64];
	DWORD	dw;
	if (!EncZPole(IsDlgButtonChecked(IDC_ENC_ZPOLE)))
	{
		SetDlgItemText(IDC_ENC_DEBUG, "ERROR: EncZPole!");
	}
	else
	{
		// for debug only
		ReadDWDataEx(0, &dw);
		wsprintf(s, "%08lX", dw);
		SetDlgItemText(IDC_ENC_DEBUG, s);
	}
}

void CRobotPwmEncDlg::InitEncSpeed(int ch) 
{
	int iStart, iEnd, i;

	if (ch==-1)
	{
		iStart=0;	iEnd=RIB_MAXENCCH-1;
	}
	else
	{
		iStart = iEnd = ch;
	}
		
	for (ch=iStart; ch<=iEnd; ch++)
	{
		for (i=0; i<10; i++)
		{
			m_adwEncDataHis[ch][i]=0;
		}
		m_bEncHisInitCnt[ch] = 0;
	}
}

void CRobotPwmEncDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	CRect rect;
	CPoint pt(point);

	GetDlgItem(IDC_ENC_GROUP)->GetWindowRect(&rect);
	ClientToScreen(&pt);
	rect.right = rect.left+10;
	rect.bottom = rect.top+10;

	if (rect.PtInRect(pt))
	{
		m_bShiftMode = !m_bShiftMode;
		if (m_bShiftMode)
			GetDlgItem(IDC_ENC_DEBUG)->ShowWindow(SW_SHOW);
		else
			GetDlgItem(IDC_ENC_DEBUG)->ShowWindow(SW_HIDE);
	}
	//if (point.
	
	CDialog::OnRButtonDown(nFlags, point);
}
